# ChunkCodecLibSnappy

This package implements the ChunkCodec interface for the following encoders and decoders
using the snappy library <https://github.com/google/snappy>

1. `SnappyCodec`, `SnappyEncodeOptions`, `SnappyDecodeOptions`

## Example

```julia-repl
julia> using ChunkCodecLibSnappy

julia> data = [0x00, 0x01, 0x02, 0x03];

julia> compressed_data = encode(SnappyEncodeOptions(), data);

julia> decompressed_data = decode(SnappyCodec(), compressed_data; max_size=length(data), size_hint=length(data));

julia> data == decompressed_data
true
```

The low level interface is defined in the `ChunkCodecCore` package.

"""
    struct SnappyEncodeOptions <: EncodeOptions
    SnappyEncodeOptions(; kwargs...)

Snappy compression using the snappy C++ library: https://github.com/google/snappy

The maximum decoded size is about 4 GB.

# Keyword Arguments

- `codec::SnappyCodec=SnappyCodec()`
"""
struct SnappyEncodeOptions <: EncodeOptions
    codec::SnappyCodec
end
function SnappyEncodeOptions(;
        codec::SnappyCodec=SnappyCodec(),
        kwargs...
    )
    SnappyEncodeOptions(
        codec,
    )
end

# This is a limit of the format
decoded_size_range(::SnappyEncodeOptions) = Int64(0):Int64(1):Int64(typemax(UInt32))

function encode_bound(e::SnappyEncodeOptions, src_size::Int64)::Int64
    if src_size > last(decoded_size_range(e))
        typemax(Int64)
    else
        # from https://github.com/google/snappy/blob/32ded457c0b1fe78ceb8397632c416568d6714a0/snappy.cc#L218C10-L218C46
        Int64(32) + src_size + src_size ÷ 6
    end
end

function try_encode!(e::SnappyEncodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize
    check_contiguous(dst)
    check_contiguous(src)
    src_size::Int64 = length(src)
    dst_size::Int64 = length(dst)
    check_in_range(decoded_size_range(e); src_size)
    ebound = encode_bound(e, src_size)
    if dst_size < ebound
        return NOT_SIZE
    end
    compressed_length = Ref(Csize_t(ebound))
    status = ccall((:snappy_compress, libsnappy), Cint,
        (Ptr{UInt8}, Csize_t, Ptr{UInt8}, Ref{Csize_t}),
        src, src_size, dst, compressed_length
    )
    if status == SNAPPY_OK
        Int64(compressed_length[])
    else
        error("Unknown snappy error: $(status)")
    end
end

module ChunkCodecLibSnappy

using snappy_jll: libsnappy

using ChunkCodecCore:
    Codec,
    EncodeOptions,
    DecodeOptions,
    check_in_range,
    check_contiguous,
    DecodingError,
    MaybeSize,
    NOT_SIZE
import ChunkCodecCore:
    decode_options,
    try_decode!,
    try_encode!,
    encode_bound,
    try_find_decoded_size,
    decoded_size_range

export SnappyCodec,
    SnappyEncodeOptions,
    SnappyDecodeOptions,
    SnappyDecodingError

# reexport ChunkCodecCore
using ChunkCodecCore: ChunkCodecCore, encode, decode
export ChunkCodecCore, encode, decode

include("libsnappy.jl")

"""
    struct SnappyCodec <: Codec
    SnappyCodec()

Snappy compression using the snappy C++ library: https://github.com/google/snappy

The maximum decoded size is about 4 GB.

See also [`SnappyEncodeOptions`](@ref) and [`SnappyDecodeOptions`](@ref)
"""
struct SnappyCodec <: Codec end
decode_options(::SnappyCodec) = SnappyDecodeOptions()

include("encode.jl")
include("decode.jl")

end # module ChunkCodecLibSnappy

"""
    SnappyDecodingError(code)

Error for data that cannot be decoded.
"""
struct SnappyDecodingError <: DecodingError
    code::Cint
end

function Base.showerror(io::IO, err::SnappyDecodingError)
    print(io, "SnappyDecodingError: snappy compressed buffer cannot be decoded, error code: ")
    print(io, err.code)
    nothing
end

"""
    struct SnappyDecodeOptions <: DecodeOptions
    SnappyDecodeOptions(; kwargs...)

Snappy decompression using the snappy C++ library: https://github.com/google/snappy

# Keyword Arguments

- `codec::SnappyCodec=SnappyCodec()`
"""
struct SnappyDecodeOptions <: DecodeOptions
    codec::SnappyCodec
end
function SnappyDecodeOptions(;
        codec::SnappyCodec=SnappyCodec(),
        kwargs...
    )
    SnappyDecodeOptions(codec)
end

function try_find_decoded_size(::SnappyDecodeOptions, src::AbstractVector{UInt8})::Int64
    check_contiguous(src)
    nbytes = Ref(Csize_t(0))
    ret = ccall((:snappy_uncompressed_length, libsnappy), Cint,
        (Ptr{Cvoid}, Csize_t, Ref{Csize_t}),
        src, length(src), nbytes
    )
    if ret == SNAPPY_OK && nbytes[] ≤ typemax(Int64)
        # success, it is safe to decompress
        Int64(nbytes[])
    else
        # it is not safe to decompress. throw an error
        throw(SnappyDecodingError(ret))
    end
end

function try_decode!(d::SnappyDecodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize
    check_contiguous(dst)
    check_contiguous(src)
    dst_size::Int64 = length(dst)
    src_size::Int64 = length(src)
    nbytes::Int64 = try_find_decoded_size(d, src)
    if dst_size < nbytes
        NOT_SIZE
    else
        uncompressed_length = Ref(Csize_t(nbytes))
        status = ccall((:snappy_uncompress, libsnappy), Cint,
            (Ptr{UInt8}, Csize_t, Ptr{UInt8}, Ref{Csize_t}),
            src, src_size, dst, uncompressed_length,
        )
        if status == SNAPPY_OK && uncompressed_length[] == nbytes
            nbytes
        else
            throw(SnappyDecodingError(status))
        end
    end
end

# Constants and c wrapper functions ported to Julia from snappy-c.h https://github.com/google/snappy/blob/1.2.1/snappy-c.h

const SNAPPY_OK = Cint(0)
const SNAPPY_INVALID_INPUT = Cint(1)
const SNAPPY_BUFFER_TOO_SMALL = Cint(2)

# The following is the original license info from snappy-c.h
#=
/*
 * Copyright 2011 Martin Gieseking <martin.gieseking@uos.de>.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *     * Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above
 * copyright notice, this list of conditions and the following disclaimer
 * in the documentation and/or other materials provided with the
 * distribution.
 *     * Neither the name of Google Inc. nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Plain C interface (a wrapper around the C++ implementation).
 */
=#

using Random: Random
using ChunkCodecLibSnappy:
    ChunkCodecLibSnappy,
    SnappyCodec,
    SnappyEncodeOptions,
    SnappyDecodeOptions,
    SnappyDecodingError
using ChunkCodecCore: decode, encode
using ChunkCodecTests: test_codec
using Test: @testset, @test_throws, @test
using Aqua: Aqua

Aqua.test_all(ChunkCodecLibSnappy; persistent_tasks = false)

Random.seed!(1234)

@testset "default" begin
    test_codec(SnappyCodec(), SnappyEncodeOptions(), SnappyDecodeOptions(); trials=100)
end
@testset "errors" begin
    # check SnappyDecodingError prints the correct error message
    @test sprint(Base.showerror, SnappyDecodingError(1)) ==
        "SnappyDecodingError: snappy compressed buffer cannot be decoded, error code: 1"
    # check that a truncated buffer throws a SnappyDecodingError
    u = UInt8[0x00]
    c = encode(SnappyEncodeOptions(), u)
    @test_throws SnappyDecodingError decode(SnappyDecodeOptions(), c[1:end-1])
    @test_throws SnappyDecodingError decode(SnappyDecodeOptions(), UInt8[])
    # check that a buffer with extra data throws a SnappyDecodingError
    @test_throws SnappyDecodingError decode(SnappyDecodeOptions(), [c; 0x00;])
end
